;**********************************************************************
;                                                                     *
;    Filename:	    rele_nas.asm                                      *
;    Date:                                                            *
;    File Version:                                                    *
;                                                                     *
;    Author:                                                          *
;    Company:                                                         *
;                                                                     * 
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files required:                                                  *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:                                                           *
;                                                                     *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************


	list      p=16F84             ; list directive to define processor
	#include <p16F84.inc>         ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_ON & _PWRTE_ON & _HS_OSC

; '__CONFIG' directive is used to embed configuration data within .asm file.
; The lables following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.




;***** VARIABLE DEFINITIONS
w_temp        EQU     0x0C        ; variable used for context saving 
status_temp   EQU     0x0D        ; variable used for context saving
COUNT0		EQU 0x10		;  
COUNT1		EQU 0x11
COUNT2		EQU 0x12

FIRST		EQU 0x14		;  
SECOND		EQU 0x15
SEC		EQU 0x16
MIN		EQU 0x17
HOUR		EQU 0x18

FLAGS		EQU 0x19		;  
SND_COUNT0	EQU 0x1A		;   
SND_COUNT1	EQU 0x1B		; 

MIN_ON		EQU 0x1C		;  
HOUR_ON		EQU 0x1D

MIN_OFF		EQU 0x1E		;  
HOUR_OFF	EQU 0x1F

CCC0		EQU 0x20
TMP		EQU 0x21

HOUR_X		EQU 0x22
MIN_X		EQU 0x23





MIN_ON_B	EQU .00			;  
HOUR_ON_B	EQU .00

MIN_OFF_B	EQU .00			;   ( 10 )
HOUR_OFF_B	EQU .15

SND_BEGIN	EQU .20
TIMER_CICKLE	EQU .256-(.100-.9)	;  








PORTA_NAPR	EQU B'00000000'		;  
PORTB_NAPR	EQU B'00010111'
PORT_RELE	EQU PORTB
PORT_SND	EQU PORTB
PORT_KEY	EQU PORTB
PORT_HL_BIG	EQU PORTB
PORT_HL_SM	EQU PORTA
RELE		EQU 3
SND		EQU 5			;      
HL_RABOTA	EQU 7
HL_PAUZA	EQU 6
HL_P		EQU 3
HL_M		EQU 2
KEY_GO		EQU 4
KEY_P		EQU 2
KEY_M		EQU 1
F_OUT		EQU 0			;   

;**********************************************************************
		ORG     0x000             ; processor reset vector
  		goto    main              ; go to beginning of program


		ORG     0x004             ; interrupt vector location
		movwf   w_temp            ; save off current W register contents
		movf	STATUS,w          ; move status register into W register
		movwf	status_temp       ; save off contents of STATUS register


	
; isr code can go here or be located as a call subroutine elsewhere
 		MOVLW TIMER_CICKLE
		MOVWF TMR0
		BCF INTCON,T0IF			;   
		
		BTFSS FLAGS,F_OUT
		GOTO PPPP1
		BSF PORTB,F_OUT
		BCF FLAGS,F_OUT
		GOTO PPPP2
PPPP1		BCF PORTB,F_OUT
		BSF FLAGS,F_OUT
PPPP2
		INCF FIRST,W			;   
		MOVF FIRST,W
		SUBLW .100
		BTFSS STATUS,Z
		GOTO PRER1
		CLRF FIRST
		INCF SECOND,F
		MOVF SECOND,W
		SUBLW .100
		BTFSS STATUS,Z
		GOTO PRER1
		CLRF SECOND
		INCF SEC,F
		MOVF SEC,W
		SUBLW .60
		BTFSS STATUS,Z
		GOTO PRER1
		CLRF SEC
		INCF MIN,F
		MOVF MIN,W
		SUBLW .60
		BTFSS STATUS,Z
		GOTO PRER1
		CLRF MIN
		INCF HOUR,F
		MOVF HOUR,W
		SUBLW .24
		BTFSS STATUS,Z
		GOTO PRER1
		CLRF HOUR

PRER1		
		BTFSS FLAGS,SND
		GOTO PRER2
		DECFSZ SND_COUNT0
		GOTO PRER4
		DECFSZ SND_COUNT1
		GOTO PRER4
		MOVLW SND_BEGIN
		MOVWF SND_COUNT0
		MOVWF SND_COUNT1
		BCF FLAGS,SND
		GOTO PRER3
PRER2		BCF PORT_SND,SND
		GOTO PRER3
PRER4		BSF PORT_SND,SND
		GOTO PRER3

PRER3
		movf    status_temp,w     ; retrieve copy of STATUS register
		movwf	STATUS            ; restore pre-isr STATUS register contents
		swapf   w_temp,f
		swapf   w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt



main

; remaining code goes here

;   
		CLRF PORTA
		BSF STATUS,RP0
		MOVLW PORTA_NAPR
		MOVWF TRISA
		BCF STATUS,RP0
		CLRF PORTA

;   
		CLRF PORTB
		BSF STATUS,RP0
		MOVLW PORTB_NAPR
		MOVWF TRISB
		BCF STATUS,RP0
		CLRF PORTB
; 
		CLRWDT
		BSF STATUS,RP0
		MOVLW B'01011000'	;   WDT c  1:1
		MOVWF OPTION_REG	;   
		BCF STATUS,RP0
		
		BSF FLAGS,F_OUT

;  
		BSF PORT_HL_BIG,HL_PAUZA
		BSF PORT_HL_BIG,HL_RABOTA
		BSF PORT_HL_SM,HL_P
		BSF PORT_HL_SM,HL_M
		BSF PORT_SND,SND
		BCF PORT_RELE,RELE
		MOVLW .20
		CALL DELAY
		BCF PORT_HL_BIG,HL_PAUZA
		BCF PORT_HL_BIG,HL_RABOTA
		BCF PORT_HL_SM,HL_P
		BCF PORT_HL_SM,HL_M
		BCF PORT_SND,SND
		BCF PORT_RELE,RELE
		MOVLW .20
		CALL DELAY
		BSF PORT_SND,SND
		MOVLW .20
		CALL DELAY
		BCF PORT_SND,SND
		MOVLW .20
		CALL DELAY
		BSF PORT_SND,SND
		MOVLW .80
		CALL DELAY
		BCF PORT_SND,SND
		MOVLW .5
		CALL DELAY

		BSF PORT_HL_BIG,HL_PAUZA
		CLRF FIRST
		CLRF SECOND
		CLRF SEC
		CLRF MIN
		CLRF HOUR
		MOVLW MIN_ON_B
		MOVWF MIN_ON
		MOVLW HOUR_ON_B
		MOVWF HOUR_ON
		MOVLW MIN_OFF_B
		MOVWF MIN_OFF
		MOVLW HOUR_OFF_B
		MOVWF HOUR_OFF
		MOVLW SND_BEGIN
		MOVWF SND_COUNT0
		MOVWF SND_COUNT1
		CLRF FLAGS

		CLRF TMR0			;  
		BSF INTCON,T0IE
		BCF INTCON,T0IF
		BSF INTCON,GIE


;               
BODY
		CLRWDT	
		BCF PORT_HL_BIG,HL_RABOTA
		BCF PORT_RELE,RELE
		BTFSS SEC,0
		GOTO BODY7A
		BSF PORT_HL_BIG,HL_PAUZA
		GOTO BODY7B	
BODY7A		BCF PORT_HL_BIG,HL_PAUZA
BODY7B		BTFSS PORT_KEY,KEY_GO		;  GO?
		GOTO GOGOGO
		BTFSS PORT_KEY,KEY_P		;  '+'?
		CALL BODY1
		BTFSS PORT_KEY,KEY_M		;  '-'?
		CALL BODY2
		GOTO BODY

BODY1						;   10   
		CLRWDT
		BSF FLAGS,SND
		BSF PORT_HL_SM,HL_P
		BSF PORT_HL_SM,HL_M
		BTFSS PORT_KEY,KEY_P
		GOTO BODY1
		MOVF MIN_OFF,W
		SUBLW .50
		BTFSS STATUS,Z
		GOTO PPP1
		CLRF MIN_OFF
		MOVF HOUR_OFF
		SUBLW .23
		BTFSS STATUS,Z
		GOTO PPP3
		CLRF HOUR_OFF
		GOTO PPP4
PPP3		INCF HOUR_OFF
		GOTO PPP4
PPP1		MOVLW .10
		ADDWF MIN_OFF,F
PPP4
;		CALL DELAY_SND
PPP7		CLRWDT
		BTFSC FLAGS,SND
		GOTO PPP7
		BCF PORT_HL_SM,HL_P
		BCF PORT_HL_SM,HL_M
		RETURN



BODY2						;   
		CLRWDT
		BSF FLAGS,SND
		BSF PORT_HL_SM,HL_P
		BSF PORT_HL_SM,HL_M
		BTFSS PORT_KEY,KEY_M
		GOTO BODY2
		MOVF MIN_OFF,F
		BTFSS STATUS,Z
		GOTO MMM1
		MOVLW .50
		MOVWF MIN_OFF
		MOVF HOUR_OFF,F
		BTFSS STATUS,Z
		GOTO MMM2
		MOVLW .23
		MOVWF HOUR_OFF
		GOTO MMM3
MMM2		DECF HOUR_OFF
		GOTO MMM3
MMM1		MOVLW .10
		SUBWF MIN_OFF,F
MMM3
;		CALL DELAY_SND
MMM7		CLRWDT
		BTFSC FLAGS,SND
		GOTO MMM7
		BCF PORT_HL_SM,HL_P
		BCF PORT_HL_SM,HL_M
		RETURN


GOGOGO_WAIT	BTFSS PORT_KEY,KEY_GO
		 
GOGOGO						;   GO
		MOVF MIN,W			;   
		MOVWF MIN_ON
		MOVF HOUR,W
		MOVWF HOUR_ON

GOGOGO1		BCF PORT_RELE,RELE
		CLRWDT
		BSF FLAGS,SND
		BTFSS PORT_KEY,KEY_GO
		GOTO GOGOGO
		MOVLW 5
		CALL DELAY
		BSF PORT_HL_BIG,HL_RABOTA
		BSF PORT_HL_BIG,HL_PAUZA

		MOVLW .30			;   
		CALL DELAY
		MOVF MIN_OFF,W
		MOVWF TMP
GOGO3		MOVF TMP,F
		BTFSC STATUS,Z
		GOTO GOGO2
GOGO1		BSF PORT_HL_SM,HL_P
		MOVLW 5
		CALL DELAY_SND
		BCF PORT_HL_SM,HL_P
		MOVLW 20
		CALL DELAY
		MOVLW .10
		SUBWF TMP,F
		GOTO GOGO3
GOGO2		MOVLW .80
		CALL DELAY

		MOVF HOUR_OFF,W			;  
		MOVWF TMP
		INCF TMP,F
GOGO6		DECFSZ TMP,F
		GOTO GOGO4
		GOTO GOGO5
GOGO4		BSF PORT_HL_SM,HL_M
		MOVLW 5
		CALL DELAY_SND
		BCF PORT_HL_SM,HL_M
		MOVLW 20
		CALL DELAY
		GOTO GOGO6
GOGO5		MOVLW .70
		CALL DELAY
		BSF FLAGS,SND
		MOVLW .90
		CALL DELAY_SND	


;  
FUCK
		BCF PORT_HL_BIG,HL_PAUZA
		BSF PORT_RELE,RELE

FUCK3		CLRWDT
		BTFSS SEC,0
		GOTO FUCK1
		BSF PORT_HL_BIG,HL_RABOTA
		GOTO FUCK2
FUCK1		BCF PORT_HL_BIG,HL_RABOTA
FUCK2		BTFSS PORT_KEY,KEY_M
		CALL BODY2ON
		BTFSS PORT_KEY,KEY_P
		CALL BODY1ON
		BTFSS PORT_KEY,KEY_GO
		GOTO BODY_WT

		


		CLRF MIN_X		;    
		CLRF HOUR_X
		MOVF MIN_ON,W
		MOVWF MIN_X
		MOVF MIN_OFF,W
		ADDWF MIN_X,F
		MOVLW .60
		SUBWF MIN_X,W
		BTFSS STATUS,C
		GOTO BLYA1
		MOVLW .196
		ADDWF MIN_X,F
		INCF HOUR_X

BLYA1		MOVF HOUR_ON,W
		ADDWF HOUR_X,F
		MOVF HOUR_OFF,W
		ADDWF HOUR_X,F
		MOVLW .24
		SUBWF HOUR_X,W
		BTFSS STATUS,C
		GOTO BLYA2
		MOVLW .232
		ADDWF HOUR_X,F
		MOVF HOUR_X,W			;   
		SUBWF HOUR,W
		BTFSS STATUS,Z
		GOTO BLYA2
		MOVF MIN_X,W
		SUBWF MIN,W
		BTFSS STATUS,Z
		GOTO BLYA2
		GOTO RAB7

BLYA2		GOTO FUCK


;      
RAB7		CLRWDT
		BCF PORT_RELE,RELE
		BTFSS SEC,0
		GOTO RAB1
		BSF PORT_HL_BIG,HL_RABOTA
		BSF PORT_HL_BIG,HL_PAUZA
		GOTO RAB2
RAB1
		BCF PORT_HL_BIG,HL_RABOTA
		BCF PORT_HL_BIG,HL_PAUZA
RAB2		BTFSS PORT_KEY,KEY_M
		CALL BODY2ON
		BTFSS PORT_KEY,KEY_P
		CALL BODY1ON
		BTFSS PORT_KEY,KEY_GO
		GOTO BODY_WT
		MOVF HOUR_ON,W			;    
		SUBWF HOUR,W
		BTFSS STATUS,Z
		GOTO RAB7
		MOVF MIN_ON,W
		SUBWF MIN,W
		BTFSS STATUS,Z
		GOTO RAB7
		GOTO FUCK

BODY_WT
		CLRWDT	
		BSF FLAGS,SND
		BTFSS PORT_KEY,KEY_GO
		GOTO BODY_WT
		MOVLW .10
		CALL DELAY
		GOTO BODY









BODY1ON					;   10   
		CLRWDT
		BSF FLAGS,SND
		BSF PORT_HL_SM,HL_P
		BSF PORT_HL_SM,HL_M
		BTFSS PORT_KEY,KEY_P
		GOTO BODY1ON

		MOVLW .10
		ADDWF MIN_ON,F
		MOVLW .60
		SUBWF MIN_ON,W
		BTFSS STATUS,C
		GOTO PPP4ON
		MOVLW .196
		ADDWF MIN_ON,F
		INCF HOUR_ON
		MOVLW .24
		SUBWF HOUR_ON,W
		BTFSC STATUS,Z
		CLRF HOUR_ON
		
		


PPP4ON
PPP7ON		CLRWDT
		BTFSC FLAGS,SND
		GOTO PPP7ON
		BCF PORT_HL_SM,HL_P
		BCF PORT_HL_SM,HL_M
		RETURN



BODY2ON						;   
		CLRWDT
		BSF FLAGS,SND
		BSF PORT_HL_SM,HL_P
		BSF PORT_HL_SM,HL_M
		BTFSS PORT_KEY,KEY_M
		GOTO BODY2ON

		MOVLW .10
		SUBWF MIN_ON,F
		BTFSC STATUS,C
		GOTO MMM3ON
		MOVLW .196
		SUBWF MIN_ON,F
		MOVF HOUR_ON,F
		BTFSC STATUS,Z
		GOTO BODY2ON2
		DECF HOUR_ON,F
		GOTO MMM3ON
BODY2ON2	MOVLW .23
		MOVWF HOUR_ON







MMM3ON
MMM7ON		CLRWDT
		BTFSC FLAGS,SND
		GOTO MMM7ON
		BCF PORT_HL_SM,HL_P
		BCF PORT_HL_SM,HL_M
		RETURN






; /  ****************************************************
; WREG -   0,1- 
 
DELAY		
		MOVWF COUNT0
DELAY3		MOVLW .30
		MOVWF COUNT1
DELAY2		MOVLW 0x80
		MOVWF COUNT2
DELAY1		CLRWDT
		DECFSZ COUNT2,F
		GOTO DELAY1
		DECFSZ COUNT1,F
		GOTO DELAY2
		DECFSZ COUNT0,F
		GOTO DELAY3
		RETURN


; /  ****************************************************
; WREG -   0,1- 
 
DELAY_SND		
		BSF PORT_SND,SND
		MOVLW 10
		MOVWF COUNT0
DELAY3S		MOVLW .30
		MOVWF COUNT1
DELAY2S		MOVLW 0x80
		MOVWF COUNT2
DELAY1S		CLRWDT
		DECFSZ COUNT2,F
		GOTO DELAY1S
		DECFSZ COUNT1,F
		GOTO DELAY2S
		DECFSZ COUNT0,F
		GOTO DELAY3S
		BCF PORT_SND,SND
		RETURN



		END                     ; directive 'end of program'

